searchNodes=[{"doc":"Provides a simple to use profiling mechanism to inspect the behavior of an application on a target VM. It utilizes Erlang's profiler tools, namely eprof , the default, fprof or cprof . Supports profiling of processes or the ability to decorate your code with, zero cost, analysis functions. For ease of use and to minimize impact on the application to be profiled ezprofiler runs as a stand-alone escript rather than an application in the same VM. That said, for code-profiling there is an option to manage ezprofiler via source code within your application for deployments where access to the VM may be limited (see below). There is a separate dependency, ezprofiler_deps , that needs to be included in the deps function of your mix.exs for code profiling to work correctly: defp deps do [ { :ezprofiler_deps , git : &quot;https://github.com/nhpip/ezprofiler_deps.git&quot; } ] end It is also possible to include ezprofiler as a dependency too: defp deps do [ { :ezprofiler , git : &quot;https://github.com/nhpip/ezprofiler.git&quot; , app : false } , { :ezprofiler_deps , git : &quot;https://github.com/nhpip/ezprofiler_deps.git&quot; } ] Profiling ezprofiler presents the user with two types of profiling, processes based and code based profiling, both controlled via a simple shell-type interface or, optionally, via code in the case of code profiling. Process Profiling Attach the profiler to specific processes, registered names or pg/pg2 groups. When profiling starts those processes will be traced. The selection of pg vs pg2 is based on the OTP release, see @pg_otp_version in lib/ezprofiler/term_helper.ex if you wish to change that behavior. Code Profiling The process option can be omitted. Instead the code can be decorated with profiling functions. In this case, to simplify the analysis, only a single (the first) process to invoke that code block will be profiled. This is useful in, for example, web-based applications where 1000's of processes maybe spawned and invoke the same code at the same time. The profiling functions incur near zero run-time cost (zero-cost when profiling is disabled), and are safe to use in prodution. Once profiling is started an insignificant run-time cost maybe incurred (the cost of a call to a GenServer ). Process Profiling This is when you know the process that you want to profile, the process is specified as a pid, registered name or PG2 group. The process or processes are specified with the command line option --processes . This coupled with the --sos (set on spawn) option can profile a process and carry on the profiling on all processes that are spawned by the target process. Included is the option to specify :ranch in the --processes option. This makes tracing of the popular Ranch socket acceptor pool, and when specified with the --sos and --sol options will follow the spawned processes that are created on an inbound TCP accept requests. The list of processes can be a simple process id, a registered name, pg/pg2 group or a list. THey must be enclosed in double quotes, for example: --processes &quot;&lt;0.1278.0&gt;&quot; --processes &quot;:my_reg_name&quot; --processes &quot;[:ranch, &lt;0.777.0&gt;, :my_reg_name, {:xyz, :server_a_pg2}]&quot; For example: $ ./ezprofiler --node myapp@localhost --processes :my_reg_pid --sos --mf &quot;_:_&quot; Options: &#39;s&#39; to start profiling when &#39;waiting&#39; &#39;a&#39; to get profiling results when &#39;profiling&#39; &#39;r&#39; to abandon (reset) profiling and go back to &#39;waiting&#39; state with initial value for &#39;u&#39; set &#39;c&#39; to enable code profiling (once) &#39;c&#39; &quot;label&quot; to enable code profiling (once) for label (an atom, string or list of either), e.g. &quot;c mylabel&quot; || &quot;c label1, label2&quot; Select &quot;c r&quot; to use the last label(s) &#39;l&#39; &quot;true | false&quot; permits transition between labels if multiple labels are specified &#39;u&#39; &quot;M:F&quot; to update the module and function to trace (only with eprof) &#39;v&#39; to view last saved results file &#39;g&#39; for debugging, returns the state on the target VM &#39;h&#39; this help text &#39;q&#39; to exit waiting..(1)&gt; Profiling has currently not started. The user selects 's' to commence profiling: waiting .. ( 1 ) &gt; s waiting .. ( 2 ) &gt; profiling ( 2 ) &gt; The utility is now profiling as seen by the change in prompt, when ready to get the results select 'a' for analyze. profiling ( 2 ) &gt; profiling ( 2 ) &gt; a * * * * * * Process &lt; 9272.3831 . 0 &gt; -- 62.53 % of profiled time * * * FUNCTION CALLS % TIME [ uS / CALLS ] -- -- -- -- -- -- - -- -- -- - -- -- [ -- -- -- -- -- ] &#39;Elixir.Ecto.Adapters.Postgres.Connection&#39; :query / 4 1 0.00 0 [ 0.00 ] &#39;Elixir.DBConnection&#39; :&#39;-transaction/3-fun-2-&#39; / 4 1 0.00 0 [ 0.00 ] &#39;Elixir.DBConnection&#39; :&#39;-execute/4-fun-0-&#39; / 5 1 0.00 0 [ 0.00 ] &#39;Elixir.DBConnection&#39; :&#39;-commit/3-fun-0-&#39; / 3 1 0.00 0 [ 0.00 ] &#39;Elixir.DBConnection&#39; :&#39;-begin/3-fun-0-&#39; / 3 1 0.00 0 [ 0.00 ] &#39;Elixir.Inspect.Atom&#39; :color_key / 1 1 0.00 0 [ 0.00 ] &#39;Elixir.Ecto.Queryable.Ecto.Query&#39; :to_query / 1 1 0.00 0 [ 0.00 ] &#39;Elixir.Ecto.Repo.Queryable&#39; :postprocessor / 4 1 0.00 0 [ 0.00 ] &#39;Elixir.Proto.Notification.AuthResponse&#39; :new / 0 1 0.00 0 [ 0.00 ] cow_http_hd :token_ci_list / 2 1 0.00 0 [ 0.00 ] &#39;Elixir.Postgrex.DefaultTypes&#39; :decode_rows / 4 2 0.00 0 [ 0.00 ] &#39;Elixir.Postgrex.DefaultTypes&#39; :&#39;-encode_params/3-anonymous-2-&#39; / 2 1 0.00 0 [ 0.00 ] lists :keystore / 4 2 0.00 0 [ 0.00 ] ... ... SNIP ... ... &#39;Elixir.Enum&#39; :&#39;-reduce/3-lists^foldl/2-0-&#39; / 3 445 8.73 235 [ 0.53 ] erts_internal :port_control / 3 3 17.69 476 [ 158.67 ] -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - -- -- - -- -- -- - -- -- [ -- -- -- -- -- ] Total : 3042 100.00 % 2691 [ 0.88 ] waiting .. ( 3 ) &gt; waiting .. ( 3 ) &gt; This can produce a lot of output since the --mf option was a wildcard. It's possible to focus in on a specific module and function and repeat. For example select the Erlang lists module. waiting .. ( 4 ) &gt; u lists :_ Updated the module and function waiting .. ( 5 ) &gt; s waiting .. ( 6 ) &gt; profiling ( 6 ) &gt; a profiling ( 7 ) &gt; * * * * * * Process &lt; 9272.3882 . 0 &gt; -- 48.30 % of profiled time * * * FUNCTION CALLS % TIME [ uS / CALLS ] -- -- -- -- -- -- - -- -- -- - -- -- [ -- -- -- -- -- ] lists :prefix / 2 7 0.09 2 [ 0.29 ] lists :keystore / 4 2 0.09 2 [ 1.00 ] lists :foreach / 2 6 0.13 3 [ 0.50 ] lists :keystore2 / 4 9 0.17 4 [ 0.44 ] lists :member / 2 5 0.17 4 [ 0.80 ] lists :reverse / 2 23 0.73 17 [ 0.74 ] lists :foldl / 3 42 0.90 21 [ 0.50 ] lists :reverse / 1 105 1.28 30 [ 0.29 ] lists :keymember / 3 4 1.62 38 [ 9.50 ] lists :keyfind / 3 133 94.83 2220 [ 16.69 ] -- -- -- -- -- -- -- -- - -- -- - -- -- -- - -- -- [ -- -- -- -- -- ] Total : 336 100.00 % 2341 [ 6.97 ] If specified with the --directory option the results can be saved and the last set of results can be re-displayed by pressing 'v' (see below). NOTE: If fprof is selected as the profiler the results will not be output to screen unless 'v' is selected. Code Profiling This permits the profiling of code dynamically. The user can decorate functions or blocks of code, and when ready the user can, from the escript, start profiling that function or block of code. The decorating is quite simple, the dependency ezprofiler_deps should be added to your application mix.exs file (see below). This contains the module ( EZProfiler.CodeProfiler ) that has stub functions that you can place throughout your code that have zero run-time cost. When the profiler connects to your application this code is hot-swapped out for a module with the same name, containing the same function names. These functions contain actual working code. The run-time cost is still minimal as only a single process will be monitored at a time, the only cost to other processes is a single gen:call to an Elixir Agent if a profiling function is called. Once ezprofiler terminates the original &quot;stub&quot; module is restored, once again ensuring zero run-time cost. The application will attempt to only show functions, and functions that those functions call, that are part of your workflow. There will however be a couple of internal ezprofiler functions included too. These functions are at the end of the profiling run and will not impact your application. If you only wish to see the function been profiled, without ezprofiler and other called functions set the --cpfo option. Alternatively select the --mf option, especially if cprof is used as the profiler. For example, this will profile anything between start_code_profiling/0 and stop_code_profiling/0 def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . start_code_profiling ( ) bar ( x ) baz ( y ) EZProfiler.CodeProfiler . stop_code_profiling ( ) end This will just profile a specific function def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . bar / 1 , [ x ] ) end Or with a label / anonymous function: def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . bar / 1 , [ x ] , :my_label ) end def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . bar / 1 , [ x ] , fn -&gt; if should_i_profile? ( foo ) , do : :my_label , else : :nok end ) end Or in a pipelne: def foo ( data ) do x = function1 ( ) data |&gt; bar ( ) |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . baz / 1 , [ x ] ) |&gt; function2 ( ) end A word about Labels Labels are used to identify what code you want to profile, where each piece of code has its own label. For example a web-server may have something like: EZProfiler.CodeProfiler . function_profiling ( &amp; ParseModule . parse_http / 1 , [ http_string ] , &quot;fred@shoes.com&quot; ) From within the CLI the user can then select: waiting .. ( 1 ) &gt; c fred @shoes . com waiting .. ( 2 ) &gt; Code profiling enabled with label ( s ) of fred @shoes . com Or from code: EZProfiler.Manager . enable_code_profiling ( &quot;fred@shoes.com&quot; ) In both those cases only a web request from fred@shoes.com will be selected for profling (using an anonymous function to select the label can make the code dynamic). Labels can be atoms , strings or when selecting code to profile a list of labels waiting .. ( 3 ) &gt; c fred @shoes . com , sue @shoes . com , :mgmt_utils waiting .. ( 4 ) &gt; Code profiling enabled with label ( s ) of fred @shoes . com , sue @shoes . com , :mgmt_utils EZProfiler.Manager . enable_code_profiling ( [ fred @shoes . com , sue @shoes . com , :mgmt_utils ] ) When using a list of labels there are two modes, label transition ( labeltran ) true or label transition false (the default). The behavior is as follows: Label Transition false This effectively a request to profile one-of those labels. The first matching label is selected for profiling and the rest of the labels are ignored. Label Transition true In this case all specified labels shall be profiled sequentially (order doesn't matter), effectively the profiler automatically re-enables profiling after a label match. A label that matches and is profiled, will removed from the list of labels to be profiled next and profiling is re-enabled for the remaining labels. This allows profiling to follow the flow of code through your application, even if processes are switched. It is important to note that the rule of only one process at a time can be profiled still exists, so ideally profiled code calls should be sequential. However, if there are sections of code that need to be profiled that overlap in time ezprofiler performs pseudo profiling . This is where ezprofiler will calculate and display how long the profiled code took to execute. Code profiling via the ezprofiler shell Invoke ezprofiler as below (no need for a process) hitting c will start profiling in this case. To abandon hit r . Code profiling still supports the --mf option (or u on the menu) to filter the results. $ ./ezprofiler --node myapp@localhost Options: &#39;s&#39; to start profiling when &#39;waiting&#39; &#39;a&#39; to get profiling results when &#39;profiling&#39; &#39;r&#39; to abandon (reset) profiling and go back to &#39;waiting&#39; state with initial value for &#39;u&#39; set &#39;c&#39; to enable code profiling (once) &#39;c&#39; &quot;label&quot; to enable code profiling (once) for label (an atom, string or list of either), e.g. &quot;c mylabel&quot; || &quot;c label1, label2&quot; Select &quot;c r&quot; to use the last label(s) &#39;l&#39; &quot;true | false&quot; permits transition between labels if multiple labels are specified &#39;u&#39; &quot;M:F&quot; to update the module and function to trace (only with eprof) &#39;v&#39; to view last saved results file &#39;g&#39; for debugging, returns the state on the target VM &#39;h&#39; this help text &#39;q&#39; to exit waiting..(1)&gt; c waiting..(2)&gt; Code profiling enabled waiting..(2)&gt; Got a start profiling from source code with label of :no_label waiting..(2)&gt; profiling(2)&gt; profiling(2)&gt; ****** Process &lt;9500.793.0&gt; -- 100.00 % of profiled time *** FUNCTION CALLS % TIME [uS / CALLS] -------- ----- ------- ---- [----------] &#39;Elixir.MyServer.CommitLog.Protocol.Encoder.Server.Types.UserInfo&#39;:encode/1 5 0.00 0 [ 0.00] &#39;Elixir.MyServer.Subscriber.Notification&#39;:new/3 1 0.00 0 [ 0.00] ...SNIP... A label can be set as follows: EZProfiler.CodeProfiler . start_code_profiling ( :my_label ) case do_send_email ( email , private_key ) do :ok -&gt; EZProfiler.CodeProfiler . stop_code_profiling ( ) Then: waiting .. ( 4 ) &gt; c my_label waiting .. ( 5 ) &gt; Code profiling enabled with a label of :my_label waiting .. ( 5 ) &gt; Got a start profiling from source code with label of :my_label Alternatively the label can be replaced with a lambda that should return a label (atom or string) if tracing is to be started, or the atom :nok if it isn't: EZProfiler.CodeProfiler . start_code_profiling ( fn -&gt; if should_i_profile? ( foo ) , do : :my_label , else : :nok end ) case do_send_email ( email , private_key ) do :ok -&gt; EZProfiler.CodeProfiler . stop_code_profiling ( ) See below for additional examples. Code profiling via source code In certain deployments access to a shell, either the Elixir/Erlang shell or a bash shell may be restricted. Instead there is limited functionality to code-profile via your application source code. Please be aware that this still requires the ezprofiler escript, which is still started in the background. This may change in future releases, but adding a profiler as a separate application does add risk to any other applications on the VM. Please see the EZProfiler.Manager module documentation for more information. There are 6 functions available for code profiling: start_ezprofiler / 0 # Starts the profiler with default configuration start_ezprofiler / 1 # Starts the profiler with custom configuration stop_ezprofler / 0 # Stops the profiler enable_profiling / 0 # Start profiling, same as `c` from the CLI enable_profiling / 1 # Start profiling with a label, same as `c label` from the CLI wait_for_results / 0 # Blocks, and waits for results (up to 5000 milliseconds) wait_for_results / 1 # Blocks, and waits for results for the time, in milliseconds allow_label_transition / 1 # Enables or disables label transition wait_for_results_non_block / 2 # As `wait_for_results` but is non-blocking. Instead a message is sent to `self()` or the specified pid get_profiling_results / 1 # Retrieves the results Compiling and Mix Execute mix compile or include ezprofiler in deps function of application mix.exs file along with ezprofiler_deps . defp deps do [ { :ezprofiler , git : &quot;https://github.com/nhpip/ezprofiler.git&quot; , app : false } , { :ezprofiler_deps , git : &quot;https://github.com/nhpip/ezprofiler_deps.git&quot; } ] end Usage ezprofiler -- help ezprofiler : -- node [ node ] : the Erlang VM you want tracing on ( e . g . myapp @localhost ) -- cookie [ cookie ] : the VM cookie ( optional ) -- processes [ pid or reg_name ] : the remote process pid ( e . g . &quot;&lt;0.249.0&gt;&quot; ) or registered name you want to trace ( other options ranch or pg / pg2 group ) -- sos : if present will apply tracing to any process spawned by the one defined in -- process -- mf [ string ] : a specification of module :fun of which module and functions to trace , with underscore _ as a wildcard . Example &quot;Foo:bar&quot; will trace calls to Foo :bar &quot;Foo:_&quot; will trace calls to all functions in module Foo ( default is &quot;_:_&quot; ) -- directory : where to store the results -- maxtime : the maximum time we wait for profiling to complete in milliseconds ( default 5000 milliseconds ) -- profiler : one of eprof , cprof or fprof , default eprof -- sort : for eprof one of time , calls , mfa ( default time ) , for fprof one of acc or own ( default acc ) . Nothing for cprof -- cpfo : when doing code profiling setting this will only profile the function and not any functions that the function calls -- labeltran : permits transition between labels if multiple labels are specified -- help : this page Additional Code Profiling Examples Code Block Profiling EZProfiler.CodeProfiler . start_code_profiling ( ) profile_fun1 ( ) profile_fun2 ( 1 .. 10 ) EZProfiler.CodeProfiler . stop_code_profiling ( ) EZProfiler.CodeProfiler . start_code_profiling ( :my_label ) profile_fun1 ( ) profile_fun2 ( 1 .. 10 ) EZProfiler.CodeProfiler . stop_code_profiling ( ) EZProfiler.CodeProfiler . start_code_profiling ( fn -&gt; shall_we_profile? ( ) end ) profile_fun1 ( ) profile_fun2 ( 1 .. 10 ) EZProfiler.CodeProfiler . stop_code_profiling ( ) Function Profiling EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . profile_fun1 / 0 ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . profile_fun1 / 0 , :my_label ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . profile_fun1 / 0 , fn -&gt; shall_we_profile? ( ) end ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . profile_fun2 / 1 , [ 1 .. 10 ] ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . profile_fun2 / 1 , [ 1 .. 10 ] , :my_label ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . profile_fun2 / 1 , [ 1 .. 10 ] , fn -&gt; shall_we_profile? ( ) end ) Pipe Profiling [ 1 , 2 , 3 , 4 ] |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . profile_fun2 / 1 ) |&gt; Enum . sum ( ) [ 1 , 2 , 3 , 4 ] |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . profile_fun2 / 1 , :my_label ) |&gt; Enum . sum ( ) [ 1 , 2 , 3 , 4 ] |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . profile_fun2 / 1 , fn -&gt; shall_we_profile? ( ) end ) |&gt; Enum . sum ( ) [ 1 , 2 , 3 , 4 ] |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . profile_fun3 / 2 , [ 77 ] ) |&gt; Enum . sum ( ) [ 1 , 2 , 3 , 4 ] |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . profile_fun3 / 2 , [ 77 ] , :my_label ) |&gt; Enum . sum ( ) [ 1 , 2 , 3 , 4 ] |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . profile_fun3 / 2 , [ 77 ] , fn -&gt; shall_we_profile? ( ) end ) |&gt; Enum . sum ( )","ref":"EZProfiler.html","title":"EZProfiler","type":"module"},{"doc":"This module handles code profiling. The user hits c or c label or EZProfiler.Manager.enable_profiling/1 and any process whose code calls one of the profiling functions is profiled. Only a single process at a time can be profiled, although label transition can assist in that. The module is loaded from the escript, replacing the one in the application, the reverse happens when the escript terminates. The module in the release has functions like: def start_profiling ( ) do end So they are mostly no-ops, with no run-time cost. There is a minimal run-time cost when the module is loaded, as much as a message to an Agent. Block Profiling Profile a block of code. If the function EZCodeProfiler.start_profiling is called, any code between that and EZCodeProfiler.stop_profiling is profiled. Function Profiling Profiles a specific function using EZProfiler.CodeProfiler.function_profiling . Pipe Profiling Profiles a function within an Elixir pipe using EZProfiler.CodeProfiler.pipe_profiling . NOTE: The function we want to profile for function profiling and pipe function is specified as a function capture. It is recommended to include the module name ( &amp;MyModule.foo/1 not &amp;foo/1 ) Labels When using either the CLI c labels or EZProfiler.Manager.enable_profiling/1 either a single label or a list of labels can be specified. In the case of a list there are two modes of operation, label transition ( labeltran ) true or label transition false (the default). The behavior is as follows: Label Transition false This effectively a request to profile one-of those labels. The first matching label is selected for profiling and the rest of the labels are ignored. Label Transition true In this case all specified labels shall be profiled sequentially (order doesn't matter), effectively the profiler automatically re-enables profiling after a label match. A label that matches and is profiled, will removed from the list of labels to be profiled next and profiling is re-enabled for the remaining labels. This allows profiling to follow the flow of code through your application, even if processes are switched. It is important to note that the rule of only one process at a time can be profiled still exists, so ideally profiled code calls should be sequential. However, if there are sections of code that need to be profiled that overlap in time ezprofiler performs pseudo profiling . This is where ezprofiler will calculate and display how long the profiled code took to execute.","ref":"EZProfiler.CodeProfiler.html","title":"EZProfiler.CodeProfiler","type":"module"},{"doc":"Profiles a specific function without any arguments or labels. Options fun: The function (capture) to profile Example def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . bar / 0 ) end","ref":"EZProfiler.CodeProfiler.html#function_profiling/1","title":"EZProfiler.CodeProfiler.function_profiling/1","type":"function"},{"doc":"Profiles a specific function with arguments and control labels/functions. Options fun: The function (capture) to profile options: Can be either a list of arguments, a label (atom or string) or anonymous function returning a label Starts profiling a function with arguments only: Example def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . bar / 1 , [ x ] ) end Starts profiling a function using label: Example def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . bar / 0 , :my_label ) end Starts profiling with an anonymous function: Example def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . bar / 0 , fn -&gt; if should_i_profile? ( y ) , do : :my_label , else : :nok end ) end Then in the ezprofiler console: waiting .. ( 1 ) &gt; c waiting .. ( 2 ) &gt; Code profiling enabled Or with a label: waiting .. ( 4 ) &gt; c :my_label , bob @foo . com waiting .. ( 5 ) &gt; Code profiling enabled with a label of :my_label , bob @foo . com waiting .. ( 5 ) &gt; Got a start profiling from source code with label of :my_label Or using EZProfiler.Manager : # Will profile :my_label and/or &quot;bob@foo.com&quot;, see main help on label transition EZProfiler.Manager . enable_profiling ( [ :my_label , &quot;bob@foo.com&quot; ] ) NOTE: If anonymous function is used it must return a label to allow profiling or the atom :nok to not profile.","ref":"EZProfiler.CodeProfiler.html#function_profiling/2","title":"EZProfiler.CodeProfiler.function_profiling/2","type":"function"},{"doc":"Profiles a specific function with arguments and control labels/functions. Options fun: The function (capture) to profile args: The list of arguments to pass to the function options: Can be either a label (atom or string) or anonymous function returning a label Starts profiling a function using arguments and a label: Example def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . bar / 1 , [ x ] , &quot;Profile 52&quot; ) end Starts profiling a function using arguments and an anonymous function: Example def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . function_profiling ( &amp; MyModule . bar / 1 , [ x ] , fn -&gt; if should_i_profile? ( y ) , do : &quot;Profile 52&quot; , else : :nok end ) end Then in the ezprofiler console: waiting .. ( 4 ) &gt; c &quot;Profile 52&quot; waiting .. ( 5 ) &gt; Code profiling enabled with a label of :my_label waiting .. ( 5 ) &gt; Got a start profiling from source code with label of &quot;Profile 52&quot; Or using EZProfiler.Manager : EZProfiler.Manager . enable_profiling ( &quot;Profile 52&quot; ) NOTE: If anonymous function is used it must return a label to allow profiling or the atom :nok to not profile.","ref":"EZProfiler.CodeProfiler.html#function_profiling/3","title":"EZProfiler.CodeProfiler.function_profiling/3","type":"function"},{"doc":"Profiles a function in a pipe without any extra arguments. Options arg: The argument passed in from the previous function/term in the sequence fun: The function (capture) to profile Example def foo ( data ) do x = function1 ( ) data |&gt; bar ( ) |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . baz / 1 ) |&gt; function2 ( ) end","ref":"EZProfiler.CodeProfiler.html#pipe_profiling/2","title":"EZProfiler.CodeProfiler.pipe_profiling/2","type":"function"},{"doc":"Profiles a specific function in a pipe with arguments and/or control labels/functions. Options arg: The argument passed in from the previous function/term in the sequence fun: The function (capture) to profile options: Can be either extra arguments, a label (atom or string) or anonymous function returning a label Starts profiling a function in a pipe using extra arguments: Example def foo ( data ) do x = function1 ( ) data |&gt; bar ( ) |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . baz / 1 , [ x ] ) |&gt; function2 ( ) end Starts profiling a function in a pipe using a label without extra arguments: Example def foo ( data ) do x = function1 ( ) data |&gt; bar ( ) |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . baz / 1 , :my_label ) |&gt; function2 ( ) end Starts profiling without extra arguments and an anonymous function: Example def foo ( data ) do x = function1 ( ) data |&gt; bar ( ) |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . baz / 1 , fn -&gt; if should_i_profile? ( x ) , do : :my_label , else : :nok end ) |&gt; function2 ( ) end","ref":"EZProfiler.CodeProfiler.html#pipe_profiling/3","title":"EZProfiler.CodeProfiler.pipe_profiling/3","type":"function"},{"doc":"Profiles a specific function in a pipe with extra arguments and control labels/functions. Options arg: The argument passed in from the previous function/term in the sequence fun: The function (capture) to profile args: The list of extra arguments to pass to the function options: Either a label (atom or string) or anonymous function returning a label Starts profiling using arguments and a label: Example def foo ( data ) do x = function1 ( ) data |&gt; bar ( ) |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . baz / 1 , [ x ] , :my_label ) |&gt; function2 ( ) end Starts profiling using arguments and an anonymous function: Example def foo ( data ) do x = function1 ( ) data |&gt; bar ( ) |&gt; EZProfiler.CodeProfiler . pipe_profiling ( &amp; MyModule . baz / 1 , [ x ] , fn -&gt; if should_i_profile? ( x ) , do : :my_label , else : :nok end ) |&gt; function2 ( ) end Then in the ezprofiler console: waiting .. ( 4 ) &gt; c :my_label waiting .. ( 5 ) &gt; Code profiling enabled with a label of :my_label waiting .. ( 5 ) &gt; Got a start profiling from source code with label of :my_label Or using EZProfiler.Manager : EZProfiler.Manager . enable_profiling ( [ :my_label , &quot;bob@foo.com&quot; ] ) NOTE: If anonymous function is used it must return a label to allow profiling or the atom :nok to not profile.","ref":"EZProfiler.CodeProfiler.html#pipe_profiling/4","title":"EZProfiler.CodeProfiler.pipe_profiling/4","type":"function"},{"doc":"Starts profiling a block of code, must call EZProfiler.CodeProfiler.stop_code_profiling() to stop and present the results. Example def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . start_code_profiling ( ) bar ( x ) baz ( y ) EZProfiler.CodeProfiler . stop_code_profiling ( ) end","ref":"EZProfiler.CodeProfiler.html#start_code_profiling/0","title":"EZProfiler.CodeProfiler.start_code_profiling/0","type":"function"},{"doc":"Starts profiling a block of code using a label (atom or string) or an anonymous function to target the results. Options options: Can be either a label (atom or string) or anonymous function returning a label Starts profiling a function using label: Example def foo ( ) do x = function1 ( ) y = function2 ( ) EZProfiler.CodeProfiler . start_code_profiling ( :my_label ) bar ( x ) baz ( y ) EZProfiler.CodeProfiler . stop_code_profiling ( ) end Starts profiling a function using an anonymous function: Example EZProfiler.CodeProfiler . start_code_profiling ( fn -&gt; if should_i_profile? ( foo ) , do : :my_label , else : :nok end ) case do_send_email ( email , private_key ) do :ok -&gt; EZProfiler.CodeProfiler . stop_code_profiling ( ) Then in the ezprofiler console: waiting .. ( 1 ) &gt; c waiting .. ( 2 ) &gt; Code profiling enabled Or with a label: waiting .. ( 4 ) &gt; c :my_label waiting .. ( 5 ) &gt; Code profiling enabled with a label of :my_label waiting .. ( 5 ) &gt; Got a start profiling from source code with label of :my_label NOTE: If anonymous function is used it must return a label to allow profiling or the atom :nok to not profile.","ref":"EZProfiler.CodeProfiler.html#start_code_profiling/1","title":"EZProfiler.CodeProfiler.start_code_profiling/1","type":"function"},{"doc":"Stops profiling a block oof code started with start_code_profiling(..)","ref":"EZProfiler.CodeProfiler.html#stop_code_profiling/0","title":"EZProfiler.CodeProfiler.stop_code_profiling/0","type":"function"}]